;--------------------------------------------------------------------------------------------------------------------------------------------------------------
.model tiny
.stack 64
.code
org 100h


;--------------------------------------------------------------------------------------------------------------------------------------------------------------
.startup

;Parse command-line options
mov al, byte ptr ds:[80h]
;We have arguments
.if al > 0
	mov ax, word ptr ds:[82h]
	;One digit 0/1
	.if al == '1'
		mov al, 1
		call Doit
	.elseif al == '0'
		xor al, al
		call Doit
	.else
		;Two digits on/off
		.switch ax
			.case 'no', 'NO', 'No', 'nO'
				mov al, 1
				call Doit
			.endc
			.case 'fo', 'FO', 'Fo', 'fO'
				xor al, al
				call Doit
			.endc
			.default
				call ShowHelp
			.endc
		.endsw
	.endif
.else
	call ShowStatus
.endif
.exit



;--------------------------------------------------------------------------------------------------------------------------------------------------------------
;Enable/Disable in AL
DoIt proc
   mov ah, 2eh
   xor dl, dl
   int 21h
   
   call ShowStatus
   ret
DoIt endp


;--------------------------------------------------------------------------------------------------------------------------------------------------------------
;Show status
ShowStatus proc
	mov dx, offset acStatus
	call PrintText
	
	mov ah, 54h
	xor dl, dl
	int 21h
	.if (al == 0)
   		mov dx, offset acOff
	.else
		mov dx, offset acOn
   .endif
   call PrintText
   ret
ShowStatus endp


;--------------------------------------------------------------------------------------------------------------------------------------------------------------
ShowHelp proc
	mov dx, offset acCopyright
	call PrintText
	
	mov dx, offset acCrLf
	call PrintText
	
	;Return
	mov al, -1
	ret
ShowHelp endp


	
;--------------------------------------------------------------------------------------------------------------------------------------------------------------
;Text in DX
PrintText proc uses ax
	mov ah, 9
	int 21h
	ret
PrintText endp

;--------------------------------------------------------------------------------------------------------------------------------------------------------------
.data
acCopyright		db 13, 10
				db "VERIFY R1.00                       (c) 2022 by Javier Gutierrez Chamorro (Guti)", 13, 10
				db "Controls whether to verify files are written correctly to a disk.", 13, 10, 10
acHelp			db "Syntax is: VERIFY [-h|on|1|off|0]", 13, 10, 10
				db "Examples:", 13, 10, 10
				db "	VERIFY -h", 13, 10
				db "	Shows this help screen.", 13, 10
				db "	VERIFY ON", 13, 10
				db "	Enable verification flag", 13, 10
				db "	VERIFY", 13, 10
				db "	Display verification flag", 13, 10, 10
				db "Type VERIFY without a parameter to display the current VERIFY setting.", 13, 10, 10
				db "More information at:", 13, 10
				db "	http://nikkhokkho.sourceforge.net/static.php?page=VERIFY", 13, 10
acCrLf			db 13, 10, '$'
acStatus		db 'VERIFY is $'
acOn			db "ON$"
acOff			db "OFF$"
end